package nl.amis.timeregistration.model;
import nl.amis.timeregistration.model.HourRegistrationViewRowImpl;
import oracle.jbo.Row;
import oracle.jbo.RowIterator;
import oracle.jbo.RowSet;
import oracle.jbo.ViewObject;
import oracle.jbo.server.ViewRowImpl;
import oracle.jbo.server.AttributeDefImpl;
import oracle.jbo.domain.Number;
//  ---------------------------------------------------------------------
//  ---    File generated by Oracle ADF Business Components Design Time.
//  ---    Custom code may be added to this class.
//  ---    Warning: Do not modify method signatures of generated methods.
//  ---------------------------------------------------------------------

public class TimesheetRecordsViewRowImpl extends ViewRowImpl  {


  public static final int ID = 0;
  public static final int TSTID = 1;
  public static final int PJTID = 2;
  public static final int DAY1 = 3;
  public static final int DAY2 = 4;
  public static final int DAY3 = 5;
  public static final int DAY4 = 6;
  public static final int DAY5 = 7;
  public static final int DAY6 = 8;
  public static final int DAY7 = 9;
  public static final int DAY8 = 10;
  public static final int DAY9 = 11;
  public static final int DAY10 = 12;
  public static final int DAY11 = 13;
  public static final int DAY12 = 14;
  public static final int DAY13 = 15;
  public static final int DAY14 = 16;
  public static final int TIMESHEET = 17;
  public static final int HOURREGISTRATIONS = 18;
  /**
   * 
   *  This is the default constructor (do not remove)
   */
  public TimesheetRecordsViewRowImpl() {
  }

  /**
   * 
   *  Gets TimesheetRecords entity object.
   */
  public TimesheetRecordsImpl getTimesheetRecords() {
    return (TimesheetRecordsImpl)getEntity(0);
  }

  /**
   * 
   *  Gets the attribute value for ID using the alias name Id
   */
  public Number getId() {
    return (Number)getAttributeInternal(ID);
  }

  /**
   * 
   *  Sets <code>value</code> as attribute value for ID using the alias name Id
   */
  public void setId(Number value) {
    setAttributeInternal(ID, value);
  }

  /**
   * 
   *  Gets the attribute value for TST_ID using the alias name TstId
   */
  public Number getTstId() {
    return (Number)getAttributeInternal(TSTID);
  }

  /**
   * 
   *  Sets <code>value</code> as attribute value for TST_ID using the alias name TstId
   */
  public void setTstId(Number value) {
    setAttributeInternal(TSTID, value);
  }

  /**
   * 
   *  Gets the attribute value for PJT_ID using the alias name PjtId
   */
  public Number getPjtId() {
    return (Number)getAttributeInternal(PJTID);
  }

  /**
   * 
   *  Sets <code>value</code> as attribute value for PJT_ID using the alias name PjtId
   */
  public void setPjtId(Number value) {
    setAttributeInternal(PJTID, value);
  }

  /**
   * Find the value of the HourRegistration.Hours attribute (corresponding with the
   * HOUR_REGISTRATION.HOURS column) for the given dayNo, the #th day of the month
   * for which this timesheet is defined.
   * @return the number of hours written on the given day
   * @param dayNo the sequence number of the day of the month for which we need the number of hours registered
   */
 private Number getDay( int dayNo) {
    RowIterator rows = getHourRegistrations();
    Number dayId = getDayId(dayNo);
    while (rows.hasNext()) {
      HourRegistrationViewRowImpl hourReg = (HourRegistrationViewRowImpl)rows.next();
      if (hourReg.getDayId().longValue()==dayId.longValue()) {
        return hourReg.getHours();
      }      
    }
    return null;
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day1
   */
  public Number getDay1() {
  return getDay(1);
  }


  /**
   * This method will find the ID from the DAYS table for the DAYNO-th day
   * in the month for the timesheet that this timesheetrecord is part of.
   * @return The ID value corresponding with the DAYS.id column, to be used for setting the DayId attribute on the HourRegistration
   * @param dayno the #th day of the month (1-31)
   * 
   * @todo add a method getDayId to timesheetsViewRowImpl that uses a Map with dayNo, dayId that 
   *       is initialized only once per timesheet
   */
private Number getDayId(int dayno) {
   ViewObject findDayVO = getApplicationModule().findViewObject("FindDayView1");
   findDayVO.setWhereClauseParam(0, new Integer(dayno));
   findDayVO.setWhereClauseParam(1, getTimesheet().getAttribute("StartDayId"));
   findDayVO.executeQuery();
   Number dayId= (Number)findDayVO.next().getAttribute("Id");
   return dayId;
}

private void removeHourRegistration( Number dayId) {

    RowIterator rows = getHourRegistrations();
    while (rows.hasNext()) {
      HourRegistrationViewRowImpl hourReg = (HourRegistrationViewRowImpl)rows.next();
      if (hourReg.getDayId().longValue()==dayId.longValue()) {
        rows.removeCurrentRow();
      }      
    }

  }


private HourRegistrationViewRowImpl getHourRegistration( Number dayId) {
try{
    RowIterator rows = getHourRegistrations();
    while (rows.hasNext()) {
      HourRegistrationViewRowImpl hourReg = (HourRegistrationViewRowImpl)rows.next();
      if (hourReg.getDayId().longValue()==dayId.longValue()) {
        return hourReg;
      }      
    }
  
    return null;
}
catch (Exception e)
{return null;}
  }

 
  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day1
   */
  public void setDay(Number value, int dayno) {
    Number dayId= getDayId(dayno);
    if (value== null) {
      // delete hourReg element 
      removeHourRegistration(dayId);         
    }
    else {
      HourRegistrationViewRowImpl hourReg = getHourRegistration(dayId);
      if (hourReg != null) {
         hourReg.setHours(value);
      }    
      else {
        RowIterator rowSet = getHourRegistrations();    
        HourRegistrationViewRowImpl row = (HourRegistrationViewRowImpl)rowSet.createRow();
        row.setHours(value);
        row.setDayId(dayId);
      }
    }
  }
  
  public void setDay1(Number value) {
    setDay( value, 1);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day2
   */
  public Number getDay2() {
  int i=0;
    return getDay(2);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day2
   */
  public void setDay2(Number value) {
    setDay( value, 2);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day3
   */
  public Number getDay3() {
    return getDay(3);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day3
   */
  public void setDay3(Number value) {
    setDay( value, 3);
  }

  /**
   * 
   *  Gets the associated <code>RowIterator</code> using master-detail link HourRegistrations
   */
  public oracle.jbo.RowIterator getHourRegistrations() {
    return (oracle.jbo.RowIterator)getAttributeInternal(HOURREGISTRATIONS);
  }

  /**
   * 
   *  getAttrInvokeAccessor: generated method. Do not modify.
   */
  protected Object getAttrInvokeAccessor(int index, AttributeDefImpl attrDef) throws Exception {
    switch (index)
      {
      case ID:
        return getId();
      case TSTID:
        return getTstId();
      case PJTID:
        return getPjtId();
      case DAY1:
        return getDay1();
      case DAY2:
        return getDay2();
      case DAY3:
        return getDay3();
      case DAY4:
        return getDay4();
      case DAY5:
        return getDay5();
      case DAY6:
        return getDay6();
      case DAY7:
        return getDay7();
      case DAY8:
        return getDay8();
      case DAY9:
        return getDay9();
      case DAY10:
        return getDay10();
      case DAY11:
        return getDay11();
      case DAY12:
        return getDay12();
      case DAY13:
        return getDay13();
      case DAY14:
        return getDay14();
      case HOURREGISTRATIONS:
        return getHourRegistrations();
      case TIMESHEET:
        return getTimesheet();
      default:
        return super.getAttrInvokeAccessor(index, attrDef);
      }
  }

  /**
   * 
   *  setAttrInvokeAccessor: generated method. Do not modify.
   */
  protected void setAttrInvokeAccessor(int index, Object value, AttributeDefImpl attrDef) throws Exception {
    switch (index)
      {
      case ID:
        setId((Number)value);
        return;
      case TSTID:
        setTstId((Number)value);
        return;
      case PJTID:
        setPjtId((Number)value);
        return;
      case DAY1:
        setDay1((Number)value);
        return;
      case DAY2:
        setDay2((Number)value);
        return;
      case DAY3:
        setDay3((Number)value);
        return;
      case DAY4:
        setDay4((Number)value);
        return;
      case DAY5:
        setDay5((Number)value);
        return;
      case DAY6:
        setDay6((Number)value);
        return;
      case DAY7:
        setDay7((Number)value);
        return;
      case DAY8:
        setDay8((Number)value);
        return;
      case DAY9:
        setDay9((Number)value);
        return;
      case DAY10:
        setDay10((Number)value);
        return;
      case DAY11:
        setDay11((Number)value);
        return;
      case DAY12:
        setDay12((Number)value);
        return;
      case DAY13:
        setDay13((Number)value);
        return;
      case DAY14:
        setDay14((Number)value);
        return;
      default:
        super.setAttrInvokeAccessor(index, value, attrDef);
        return;
      }
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day12
   */
  public Number getDay12() {
 return getDay(12);  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day12
   */
  public void setDay12(Number value) {
    setDay( value, 12);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day14
   */
  public Number getDay14() {
 return getDay(14);  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day14
   */
  public void setDay14(Number value) {
    setDay( value, 14);
  }

  /**
   * 
   *  Gets the associated <code>Row</code> using master-detail link Timesheet
   */
  public Row getTimesheet() {
    return (Row)getAttributeInternal(TIMESHEET);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day4
   */
  public Number getDay4() {
    return getDay(4);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day4
   */
  public void setDay4(Number value) {
    setDay( value, 4);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day5
   */
  public Number getDay5() {
    return getDay(5);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day5
   */
  public void setDay5(Number value) {
    setDay( value, 5);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day6
   */
  public Number getDay6() {
    return getDay(6);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day6
   */
  public void setDay6(Number value) {
    setDay( value, 6);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day7
   */
  public Number getDay7() {
    return getDay(7);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day7
   */
  public void setDay7(Number value) {
    setDay( value, 7);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day8
   */
  public Number getDay8() {
    return getDay(8);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day8
   */
  public void setDay8(Number value) {
    setDay( value, 8);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day9
   */
  public Number getDay9() {
    return getDay(9);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day9
   */
  public void setDay9(Number value) {
    setDay( value, 9);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day10
   */
  public Number getDay10() {
    return getDay(10);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day10
   */
  public void setDay10(Number value) {
    setDay( value, 10);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day11
   */
  public Number getDay11() {
    return getDay(11);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day11
   */
  public void setDay11(Number value) {
    setDay( value, 11);
  }

  /**
   * 
   *  Gets the attribute value for the calculated attribute Day13
   */
  public Number getDay13() {
    return getDay(13);
  }

  /**
   * 
   *  Sets <code>value</code> as the attribute value for the calculated attribute Day13
   */
  public void setDay13(Number value) {
    setDay( value, 13);
  }
}